
/* static char sccsid[] = "@(#)cpic.h	1.8 15 Sep 1994 Copyr 1993 Sun Micro";*/

#define CM_INT32 long int
#define CM_PTR *

/* from page 148 of SAA CPIC Reference */

/* converstation states */

#define CM_RESET						1
#define CM_INITIALIZE_STATE				2
#define CM_SEND_STATE					3
#define CM_RECEIVE_STATE				4	
#define CM_SEND_PENDING_STATE			5
#define CM_CONFIRM_STATE				6
#define CM_CONFIRM_SEND_STATE			7
#define CM_CONFIRM_DEALLOCATE_STATE		8
#define CM_DEFER_RECEIVE_STATE			9
#define CM_DEFER_DEALLOCATE_STATE		10
#define CM_SYNC_POINT_STATE				11
#define CM_SYNC_POINT_SEND_STATE		12
#define CM_SYNC_POINT_DEALLOCATE_STATE	13

/* conversation types */

#define CM_BASIC_CONVERSATION		0
#define CM_MAPPED_CONVERSATION		1

/* data_received */

#define CM_NO_DATA_RECEIVED			0
#define CM_DATA_RECEIVED			1
#define CM_COMPLETE_DATA_RECEIVED 	2
#define CM_INCOMPLETE_DATA_RECEIVED	3

/* deallocate type */

#define CM_DEALLOCATE_SYNC_LEVEL	0
#define CM_DEALLOCATE_FLUSH			1
#define CM_DEALLOCATE_CONFIRM		2
#define CM_DEALLOCATE_ABEND			3

/* error_direction */

#define CM_RECEIVE_ERROR		0
#define CM_SEND_ERROR			1

/* fill */

#define CM_FILL_LL     			0
#define CM_FILL_BUFFER  		1

/* prepare_to_receive_type */

#define CM_PREP_TO_RECEIVE_SYNC_LEVEL	0
#define CM_PREP_TO_RECEIVE_FLUSH		1
#define CM_PREP_TO_RECEIVE_CONFIRM		2

/* receive_type */

#define CM_RECEIVE_AND_WAIT			0
#define CM_RECEIVE_IMMEDIATE		1

/* request_to_send_received */

#define CM_REQ_TO_SEND_NOT_RECEIVED	0
#define CM_REQ_TO_SEND_RECEIVED		1

/* from page 149 of SAA CPI Reference */

/* return_code */

#define CPIC_IMPOSSIBLE					-1
#define CM_OK							0
#define CM_ALLOCATE_FAILURE_NO_RETRY	1
#define CM_ALLOCATE_FAILURE_RETRY		2
#define CM_CONVERSATION_TYPE_MISMATCH	3
#define CM_PIP_NOT_SPECIFIED_CORRECTLY	5
#define CM_SECURITY_NOT_VALID			6
#define CM_SYNC_LVL_NOT_SUPPORTED_LU	7
#define CM_SYNC_LVL_NOT_SUPPORTED_PGM	8
#define CM_TPN_NOT_RECOGNIZED			9
#define CM_TP_NOT_AVAILABLE_NO_RETRY	10
#define CM_TP_NOT_AVAILABLE_RETRY		11
#define CM_DEALLOCATED_ABEND			17
#define CM_DEALLOCATED_NORMAL			18
#define CM_PARAMETER_ERROR				19
#define CM_PRODUCT_SPECIFIC_ERROR		20
#define CM_PROGRAM_ERROR_NO_TRUNC		21
#define CM_PROGRAM_ERROR_PURGING		22
#define CM_PROGRAM_ERROR_TRUNC			23
#define CM_PROGRAM_PARAMETER_CHECK		24
#define CM_PROGRAM_STATE_CHECK			25
#define CM_RESOURCE_FAILURE_NO_RETRY	26
#define CM_RESOURCE_FAILURE_RETRY		27
#define CM_UNSUCCESSFUL					28
#define CM_DEALLOCATED_ABEND_SVC		30
#define CM_DEALLOCATED_ABEND_TIMER		31
#define CM_SVC_ERROR_NO_TRUNC			32
#define CM_SVC_ERROR_PURGING			33
#define CM_SVC_ERROR_TRUNC				34
#define CM_TAKE_BACKOUT					100
#define CM_DEALLOCATED_ABEND_BO			130
#define CM_DEALLOCATED_ABEND_SVC_BO		131
#define CM_DEALLOCATED_ABEND_TIME_BO	132
#define CM_RESOURCE_FAIL_NO_RETRY_BO	133
#define CM_RESOURCE_FAILURE_RETRY_BO	134
#define CM_DEALLOCATED_NORMAL_BO		135

/*
 *  sun-defined error returns (start at 300)
 */

#define CM_SUN_E_CPIC_NSDNSIF		300	/* no symdestname in side info file */
#define CM_SUN_E_CPIC_NM			301 /* could not match */
										/* symdestname/mode/fqplu in side */
										/* info file */
#define CM_SUN_E_CPIC_CNOF			302 /* couldn't open side info file */
#define CM_SUN_E_CPIC_MDTL			303 /* mode name invalid length */
#define CM_SUN_E_CPIC_MNICS			304 /* mode invalid character set */
#define CM_SUN_E_CPIC_PLNTL			305 /* partner lu invalid length */
#define CM_SUN_E_CPIC_PLICS			306 /* partner lu invalid character set */
#define CM_SUN_E_CPIC_TPNTL			307 /* tp name too long */
#define CM_SUN_E_CPIC_TPICS			308 /* tp name invalid character set */
#define CM_SUN_E_CPIC_SYMDESTNAME	309 /* sym dest name != 8 bytes long */
#define CM_SUN_E_NO_GW_NAME_ENV		330 /* APPC_GATEWAY env vare not defined */
#define CM_SUN_E_NO_SI_FILE_ENV		331 /* CPIC_SI env variable not defined */
#define CM_SUN_E_NO_TP_NAME_ENV		332 /* TP_ACCEPT_NAME env var undefined */

#define CPIC_SI "CPIC_SI"			/* env var for side info filename */


/* return_control */

#define CM_WHEN_SESSION_ALLOCATED	0
#define CM_IMMEDIATE				1

/* send_type */

#define CM_BUFFER_DATA				0
#define CM_SEND_AND_FLUSH			1
#define CM_SEND_AND_CONFIRM			2
#define CM_SEND_AND_PREP_TO_RECEIVE	3
#define CM_SEND_AND_DEALLOCATE		4

/* status_received */

#define CM_NO_STATUS_RECEIVED		0
#define CM_SEND_RECEIVED			1
#define CM_CONFIRM_RECEIVED			2
#define CM_CONFIRM_SEND_RECEIVED	3
#define CM_CONFIRM_DEALLOC_RECEIVED	4
#define CM_TAKE_COMMIT				5
#define CM_TAKE_COMMIT_SEND			6
#define CM_TAKE_COMMIT_DEALLOCATE	7

/* sync_level */

#define CM_NONE 				0 
#define CM_CONFIRM      		1
#define CM_SYNC_POINT  			2


/* from Appendix H of SAA CPI Reference */

#define XC_SECURITY_NONE	0
#define XC_SECURITY_SAME	1
#define XC_SECURITY_PROGRAM	2

/* for lowercase calling of cpi-c commands */

#define cmaccp CMACCP
#define cminit CMINIT
#define cmallc CMALLC
#define cmflus CMFLUS
#define cmcfm CMCFM
#define cmcfmd CMCFMD
#define cmdeal CMDEAL
#define cmecs CMECS
#define cmect CMECT
#define cmemn CMEMN
#define cmepln CMEPLN
#define cmesl CMESL
#define cmsct CMSCT
#define cmsdt CMSDT
#define cmsed CMSED
#define cmsf CMSF
#define cmsld CMSLD
#define cmsmn CMSMN
#define cmsptr CMSPTR
#define cmspln CMSPLN
#define cmsrt CMSRT
#define cmsrc CMSRC
#define cmsst CMSST
#define cmssl CMSSL
#define cmstpn CMSTPN
#define cmtrts CMTRTS
#define cmptr CMPTR
#define cmrcv CMRCV
#define cmrts CMRTS
#define cmsend CMSEND
#define cmserr CMSERR

#define xcecst XCECST
#define xcecsu XCECSU
#define xcscsp XCSCSP
#define xcscst XCSCST
#define xcscsu XCSCSU

